<xsl:stylesheet version="1.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:template name="loop">
    <xsl:param name="from"/>
    <xsl:param name="to"/>

    <xsl:choose>
      <xsl:when test="$from &gt; $to"/>
      <xsl:when test="$from = $to">
        <xsl:call-template name="body">
          <xsl:with-param name="iter" select="$from"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:variable name="middle" 
                      select="$from + floor(($to - $from) div 2)"/>

        <xsl:call-template name="loop">
          <xsl:with-param name="from" select="$from" />
          <xsl:with-param name="to" select="$middle" />
        </xsl:call-template>
        <xsl:call-template name="loop">
          <xsl:with-param name="from" select="$middle+1" />
          <xsl:with-param name="to" select="$to" />
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

</xsl:stylesheet>
